<?php
/*******************************************************************************/
//                          InstantCMS v1.9                                    //
//                      http://www.instantcms.ru/                              //
//                         plugin p_contextlinks v2.2                          //
//                     written by Marat Fatikhov  aka Марат                    //
//					   modified by googlebot                                   //
//                     http://www.instantcms.ru/users/marat                    //
//                       E-mail: f-marat@mail.ru                               //
//                                                                             //
//                      LICENSED BY GNU/GPL v2                                 //
//                                                                             //
/********************************************************************************/

class p_contextlinks extends cmsPlugin {

// ==================================================================== //

    public function __construct(){
        
        parent::__construct();

        // Информация о плагине

        $this->info['plugin']           = 'p_contextlinks';
        $this->info['title']            = 'Контекстные ссылки';
        $this->info['description']      = 'Создает из выбранных слов контекстные ссылки';
        $this->info['author']           = 'Marat Fatikhov & googlebot';
        $this->info['version']          = '2.2';

        // Настройки по-умолчанию

        $this->config['Слово|ссылка|квантификатор(необяз.)<br />Каждая пара(тройка) с нов. строки']   = "";
        $this->config['Количество замен на страницу. Пусто - все']   = '';
		$this->config['Пост блога']   = 1;
		$this->config['Список постов блога']   = 1;
		$this->config['Комментарии']   = 1;
		$this->config['Форум']   = 1;
		$this->config['Стена пользователя']   = 1;
		$this->config['Статья']   = 1;
		$this->config['Список статей']   = 1;
		$this->config['Объект InstantMaps']   = 1;

        // События, которые будут отлавливаться плагином

        $this->events[]                 = 'GET_POSTS';
        $this->events[]                 = 'GET_POST';
        $this->events[]                 = 'GET_LATEST_POSTS';
        $this->events[]                 = 'GET_BEST_POSTS';
        $this->events[]                 = 'GET_COMMENTS';
        $this->events[]                 = 'GET_FORUM_POSTS';
        $this->events[]                 = 'GET_WALL_POSTS';
        $this->events[]                 = 'GET_ARTICLE';
        $this->events[]                 = 'GET_ARTICLES';
		$this->events[]                 = 'GET_MAP_OBJECT';

    }

// ==================================================================== //

    /**
     * Процедура установки плагина
     * @return bool
     */
    public function install(){

        return parent::install();

    }

// ==================================================================== //

    /**
     * Процедура обновления плагина
     * @return bool
     */
    public function upgrade(){

        return parent::upgrade();

    }

// ==================================================================== //

    /**
     * Обработка событий
     * @param string $event
     * @param mixed $item
     * @return mixed
     */
    public function execute($event, $item){

        parent::execute();

        switch ($event){
            case 'GET_POST': if($this->config['Пост блога']!= 0){$item = $this->eventGetPost($item);} break;
            case 'GET_POSTS': if($this->config['Список постов блога']!= 0){$item = $this->eventGetPosts($item);} break;
            case 'GET_LATEST_POSTS': if($this->config['Список постов блога']!= 0){$item = $this->eventGetPosts($item);} break;
            case 'GET_BEST_POSTS': if($this->config['Список постов блога']!= 0){$item = $this->eventGetPosts($item);} break;
            case 'GET_COMMENTS': if($this->config['Комментарии']!= 0){$item = $this->eventGetComments($item);} break;
            case 'GET_FORUM_POSTS': if($this->config['Форум']!= 0){$item = $this->eventGetComments($item);} break;
            case 'GET_WALL_POSTS': if($this->config['Стена пользователя']!= 0){$item = $this->eventGetComments($item);} break;
            case 'GET_ARTICLE': if($this->config['Статья']!= 0){$item = $this->eventGetArticle($item);} break;
            case 'GET_ARTICLES': if($this->config['Список статей']!= 0){$item = $this->eventGetArticles($item);} break;
			case 'GET_MAP_OBJECT': if($this->config['Объект InstantMaps']!= 0){$item = $this->eventGetMapObject($item);} break;
        }

        return $item;

    }

// ==================================================================== //

    private function makeLink($text){

        $string        = trim($this->config['Слово|ссылка|квантификатор(необяз.)<br />Каждая пара(тройка) с нов. строки']);
		if (!$string) { return $text; }
        $limit          = $this->config['Количество замен на страницу. Пусто - все'];

        $toArray = explode("\n", $string);
        for($i=0; $i<sizeof($toArray); $i++){
            list($pattern[$i],$replacement[$i],$quant[$i]) = explode("|", trim($toArray[$i]));
        }
        //приводим ссылки к 1 виду и ключи к рег. выражениям
        for($i=0; $i<sizeof($replacement); $i++){
            $replacement[$i] = htmlspecialchars(strip_tags(trim($replacement[$i])));
			$quant[$i] = intval(trim($quant[$i]));
			if($replacement[$i]{0} != '/'){
            $replacement[$i] = 'http://'.str_replace('http://', '', $replacement[$i]);
			} else {$replacement[$i] = 'http://'.$_SERVER['HTTP_HOST'].$replacement[$i];}
			//проверка соответствия текущей странице
			if ($replacement[$i] == 'http://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI']){
				$ind[$i] = $i;
			} else {
				if (!is_numeric($quant[$i])||$quant[$i] == 0) {
					$pattern[$i] = '/\b('.trim($pattern[$i]).')\b/ius';
					$replacement[$i] = '<a href="'.$replacement[$i].'">$1</a>';
				} else {
					$pattern[$i] = '/\b([A-Za-zа-яА-ЯёЁ0-9]{0,'.$quant[$i].'})('.trim($pattern[$i]).')([A-Za-zа-яА-ЯёЁ0-9]{0,'.$quant[$i].'})\b/ius';
					$replacement[$i] = '<a href="'.$replacement[$i].'">$1$2$3</a>';
				}
			}
        }
		//переиндексация массивов
		if (is_array($ind)) {
			foreach($ind as $i) {
				unset ($replacement[$i], $pattern[$i]);
			}
			$pattern = array_values($pattern);
			$replacement = array_values($replacement);
		}

        //если массив шаблонов отличается от массива замен, ничего не меняем
        if(count($pattern) != count($replacement)){ return $text; }

        //проверяем, число ли
        if(!is_numeric($limit)){ $limit = -1; }
        
		// запоминаем нежелательные участки текста в массив
		$regexp = '/(<a\s+[^>]*>[\W\w]*?<\/a>|<iframe[^>]*>[\W\w]*?<\/iframe>|<script[^>]*>[\W\w]*?<\/script>|<object[^>]*>[\W\w]*?<\/object>|<embed[^>]*>[\W\w]*?<\/embed>|<[^>]*?>)/iu';
		preg_match_all($regexp, $text, $remember);
		
		// меняем эти участки на плейсхолдер
		$placeholder = '{placeholder}';
		$text = preg_replace($regexp, $placeholder, $text);

        // вставляем в очищенный текст перелинковку
		$text = preg_replace($pattern, $replacement, $text, $limit);

		// возвращаем очищенное
		$p = '/('.$placeholder.')/';
		if (count($remember[0])){
			foreach($remember[0] as $r){
				$text = preg_replace($p, $r, $text, 1);
				}
			}

		return $text;

    }

    private function eventGetPost($item) {

        if (!is_array($item)){ return $item; }

        $item['content_html'] = $this->makeLink($item['content_html']);

        return $item;

    }

    private function eventGetPosts($items){

        if (!is_array($items)){ return $items; }

        foreach($items as $i=>$item){
            $items[$i]['content_html'] = $this->makeLink($item['content_html']);
        }
        
        return $items;
    }

    private function eventGetComments($items){

        if (!is_array($items)){ return $items; }

        foreach($items as $i=>$item){
            $items[$i]['content'] = $this->makeLink($item['content']);
        }

        return $items;
    }
    
    private function eventGetArticle($item){

        if (!is_array($item)){ return $item; }

           $item['content'] = $this->makeLink($item['content']);

        return $item;
    }
    
    private function eventGetArticles($items){

        if (!is_array($items)){ return $items; }

        foreach($items as $i=>$item){
            $items[$i]['description'] = $this->makeLink($item['description']);
        }

        return $items;
    }
    
    private function eventGetMapObject($item){

        if (!is_array($item)){ return $item; }

           $item['description'] = $this->makeLink($item['description']);

        return $item;
    }
   
// ==================================================================== //

}

?>
